/**
 * https://github.com/emotion-js/emotion/tree/main/packages/sheet
 */
import { Rules, StyleSheetOptions } from './types';
export interface OldRule {
  tag: HTMLStyleElement;
  index: number;
  tagIndex?: number;
}
export declare class StyleSheet {
  /**
   * used to record whether another rule is inserted before
   */
  private alreadyInsertedOrderInsensitiveRule;
  /**
   * used to record the number of inserts
   */
  private insertIndex;
  /**
   * insert a list of style tags
   */
  tags: HTMLStyleElement[];
  /**
   * Using Node instead of HTMLElement since container may be a ShadowRoot
   */
  container: Node;
  /**
   * random value
   * https://web.dev/csp/
   */
  nonce?: string;
  /**
   * this will be set as the value of the style tag attribute that get inserted.
   */
  key: string;
  /**
   * ssr css data
   */
  ssrData: any[];
  /**
   * ssr global css data
   */
  ssrGlobalData: any[];
  constructor(options: StyleSheetOptions);
  insertTag(tag: HTMLStyleElement): void;
  insertStyle({ ruleCode, segmentRuleCode }: Rules, glob?: boolean): OldRule[];
  insert(rule: string): OldRule;
  flushSingle({ tag, index }: { tag: HTMLStyleElement; index: number }): void;
  flush(type?: 'all' | 'global'): void;
}
